/* convert.c 
   Copyright 1999 Carnegie Mellon University
   This program is free software.  You may copy it according
   to the conditions of the GNU General Public License version 2.0
   or later; see the file COPYING in the source directory.
*/
#include "mc.h"

#include <string.h>
#pragma intrinsic (strcmp, strlen, strcpy)

#pragma VxD_LOCKED_CODE_SEG
#pragma VxD_LOCKED_DATA_SEG


PCTENTRY create_new_entry(PCHAR s, PCHAR l){
	PCTENTRY p = _HeapAllocate(sizeof(CTENTRY), 0);
	if (!p) return NULL;
	p->next = NULL;
	strcpy(p->shortname, s);
	strcpy(p->longname, l);
	return p;
}

void add_entry(PCTENTRY head, PCTENTRY entry){
	PCTENTRY p = NULL;
	for (p = head; p->next; p = p->next);
	p->next = entry;
}
int lookup_shortbasis(PCTENTRY head, PCHAR basis){
	PCTENTRY act = head;
	int found = 0;
	while (act->next) {
		act = act->next;
		if (!strcmp(act->shortname, basis)) found++;
	}
	return found;
}

void make_short(PCTENTRY head, PCHAR *shortname, PCHAR longname){
	USHORT  Unilongname[MAX_PATH];
	USHORT  Basisname[11], name_8_3[12];
	CHAR	Basisstr[11];

	int		count;
	strcpy(*shortname, longname);
	/* convert to unicode */
	BCSToUni(Unilongname, longname, strlen(longname), BCS_OEM); 
	logucode(Unilongname);
	/* create basis name and convert to char*/
	if (CreateBasis(Basisname, Unilongname, strlen(longname) * 2) & BASIS_TRUNC){
		if (strcmp(".", longname) != 0 && strcmp("..", longname) != 0){
			UniToBCS(Basisstr, Basisname, 22, 11, BCS_OEM);
			Basisstr[11] = '\0';
			/* lookup amount of existing entries with this basis name */
			logmsg(Basisstr);
			count = lookup_shortbasis(head, Basisstr);	
			/* add numeric tail */
			logucode(Basisname);
			AppendBasisTail(Basisname, count+1);
			logucode(Basisname);
			FcbToShort(name_8_3, Basisname, FALSE);
			logucode(name_8_3);
			/* convert to char */
			UniToBCS(*shortname, name_8_3, 24, 12, BCS_OEM);
			*shortname[13] = '\0';
		}
	} 

}


void convert_table_add(PCTENTRY head, PCHAR *s, PCHAR l){
	PCTENTRY p = NULL;
	logmsg("convert_table_add l: ");logmsg(l);
	make_short(head, s, l);
	logmsg("convert_table_add s: ");logmsg(*s);
	p = create_new_entry(*s, l);
	if (p)
		add_entry(head, p);
	else logmsg("cound not create entry for convertion table;");
}
void convert_table_init(PCTENTRY head){
	strcpy(head->shortname, "");
	strcpy(head->longname, "");
	head->next = NULL;
}
void convert_table_flush(PCTENTRY head){
	PCTENTRY act = head;
	PCTENTRY last = NULL;
	while (act->next){
		last = act;
		act = act->next;
		if (last != head) _HeapFree(last, 0);		
	}
	if (act != head) _HeapFree(act, 0);		
}
