// CodaMsgList.cpp : implementation file
//

#include "stdafx.h"
#include "CodaStart.h"
#include "CodaLSock.h"
#include "CodaMsgList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCodaMsgList

CCodaMsgList::CCodaMsgList()
{
	// Get imagelist
	m_imageList.Create (IDR_CODAMSGIMGS, 12, 1, CLR_NONE);
}

CCodaMsgList::~CCodaMsgList()
{
}


BEGIN_MESSAGE_MAP(CCodaMsgList, CListCtrl)
	//{{AFX_MSG_MAP(CCodaMsgList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaMsgList message handlers

BOOL CCodaMsgList::Attach(CListCtrl* pList)
{
	// Get a socket
	if (!m_sock.Create (this)) {
		AfxMessageBox(IDP_SOCKET_CREATE_FAILED);
		return FALSE;
	}

	if (!CWnd::Attach(pList->m_hWnd))
		return FALSE;

	SetImageList (&m_imageList, LVSIL_SMALL);

	InsertColumn (0, "Opcode", LVCFMT_LEFT, 100);
	InsertColumn (1, "Unique", LVCFMT_RIGHT, 50);
	InsertColumn (2, "VFid", LVCFMT_LEFT, 108);
	InsertColumn (3, "Other information", LVCFMT_LEFT, 238);
	InsertColumn (4, "Number", LVCFMT_RIGHT, 50);

	ModifyStyle (LVS_TYPEMASK, LVS_REPORT);

	m_cMsgs = 0;
	return TRUE;
}

void CCodaMsgList::SetListen (BOOL b)
{
	m_bListening = b;
}

void CCodaMsgList::Reset ()
{
	DeleteAllItems();
	m_cMsgs = 0;
}

PTCHAR CCodaMsgList::getString (struct stringList *sl, DWORD dw, PTCHAR szTblName) 
{
	static TCHAR szBuf[100];
	while (sl && sl->sl_szName) {
		if (dw == sl->sl_dwValue)
			return sl->sl_szName;
		sl++;
	}

	_stprintf (szBuf, _TEXT("%s #%d"), szTblName, dw);
	return szBuf;
}

typedef u_long VolumeId;
typedef u_long VnodeId;
typedef u_long Unique;
typedef struct ViceFid {
    VolumeId Volume;
    VnodeId Vnode;
    Unique Unique;
} ViceFid;
#define VICEFID_DEFINED 1

#define KERNEL
#include "cfs.h"


CString printVFid(ViceFid *vfid)
{
  CString str;
  str.Format("%lx,%ld,%ld", vfid->Volume, vfid->Vnode, vfid->Unique);
  return str;
}

CString printAttr(struct vattr *p)
{
  CString str;
  str.Format("mode %x nlink %d uid %d gid %d size %ld ",
	  p->va_mode, p->va_nlink, p->va_uid, p->va_gid,
	  p->va_size);
  return str;
}


// Add a received message to the list box

void CCodaMsgList::addCodaRequest (PCHAR p, DWORD cb)
{
	struct inputArgs *in = (struct inputArgs *) p;
	CString str, str2, strvfid;

	if (!m_bListening)
		return;

	InsertItem (m_cMsgs, getString(m_slOpcode, in->opcode, _TEXT("opcode")), 0);

	str.Format(_TEXT("%d"), in->unique);
	SetItemText (m_cMsgs, 1, str);

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	str = _TEXT("");
	switch (in->opcode) {
	case CFS_OPEN:
		strvfid = printVFid (&in->d.cfs_open.VFid);
        str2.Format(_TEXT("flags %d "), in->d.cfs_open.flags);
		str += str2;
	    break;
	case CFS_LOOKUP:
		strvfid = printVFid (&in->d.cfs_lookup.VFid);
		str += _TEXT("\"");
		str += (PCHAR) (p + (int) in->d.cfs_lookup.name);
		str += _TEXT("\"");
	    break;
	case CFS_CREATE:
		strvfid = printVFid (&in->d.cfs_create.VFid);
		str += _TEXT("\"");
		str += (PCHAR) (p + (int) in->d.cfs_create.name);
		str += _TEXT("\" ");
        str2.Format(_TEXT("mode %d"), in->d.cfs_create.mode);
		str += str2;
		break;
	case CFS_CLOSE:
		strvfid = printVFid (&in->d.cfs_close.VFid);
		str2.Format(_TEXT("flags %d "), in->d.cfs_close.flags);
		str += str2;
		break;
	case CFS_GETATTR:
		strvfid = printVFid (&in->d.cfs_getattr.VFid);
		break;
	case CFS_SETATTR:
		strvfid = printVFid (&in->d.cfs_setattr.VFid);
		str += printAttr(&in->d.cfs_setattr.attr);
		break;
	case CFS_IOCTL:
		strvfid = printVFid (&in->d.cfs_ioctl.VFid);
		str2.Format (_TEXT("code %d"), in->d.cfs_ioctl.cmd);
		str += str2;
		break;
	}

	SetItemText(m_cMsgs, 2, strvfid);
	SetItemText(m_cMsgs, 3, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

void CCodaMsgList::addCodaReply (PCHAR p, DWORD cb)
{
	struct outputArgs *out = (struct outputArgs *) p;
	CString str, str2, strvfid;

	if (!m_bListening)
		return;

    if (out->opcode >= CFS_REPLACE && out->opcode <= CFS_PURGEFID) {
		// downcall from Venus to MiniCache

		InsertItem(m_cMsgs, getString(m_slOpcode, out->opcode, _TEXT("opcode")), 1);
		SetItemText(m_cMsgs, 1, _TEXT("(DOWNCALL)"));

		strvfid = "";
		switch (out->opcode) {
		case CFS_ZAPFILE:
			strvfid = printVFid(&out->d.cfs_zapfile.CodaFid);
			break;
		case CFS_ZAPDIR:
			strvfid = printVFid(&out->d.cfs_zapdir.CodaFid);
			break;
		case CFS_ZAPVNODE:
			strvfid = printVFid(&out->d.cfs_zapvnode.VFid);
			break;
		case CFS_PURGEFID:
			strvfid = printVFid(&out->d.cfs_purgefid.CodaFid);
			break;
		}
		SetItemText(m_cMsgs, 2, strvfid);
	} else if (out->opcode >= 99) {
		// administrative message to relay process
		InsertItem(m_cMsgs, getString(m_slOpcode, out->opcode, _TEXT("opcode")), 3);
	} else {
		if (out->result) {
			// error reply to minicache request
			InsertItem(m_cMsgs, getString(m_slOpcode, out->opcode, _TEXT("opcode")), 2);

			str.Format (_TEXT("%d"), out->unique);
			SetItemText(m_cMsgs, 1, str);

			str = getString(m_slErrno, out->result, _TEXT("errno"));
			SetItemText(m_cMsgs, 3, str);
		} else {
			// success reply to minicache request
			InsertItem(m_cMsgs, getString(m_slOpcode, out->opcode, _TEXT("opcode")), 1);

			str.Format (_TEXT("%d"), out->unique);
			SetItemText(m_cMsgs, 1, str);

			str = "";

			switch (out->opcode) {
			case CFS_ROOT:
				strvfid = printVFid(&out->d.cfs_root.VFid);
				break;

			case CFS_GETATTR:
				str += printAttr(&out->d.cfs_getattr.attr);
				break;
			  
			case CFS_LOOKUP:
				strvfid = printVFid(&out->d.cfs_lookup.VFid);
				str2.Format(_TEXT("type %d"), out->d.cfs_lookup.vtype);
				str += str2;
				break;

			case CFS_OPEN:
				str2.Format(_TEXT("dev %d inode %d"), out->d.cfs_open.dev, 
				  out->d.cfs_open.inode);
				str += str2;
				break;

			case CFS_CREATE:
				strvfid = printVFid(&out->d.cfs_create.VFid);
				str += printAttr(&out->d.cfs_create.attr);
				break;

			case CFS_IOCTL:
				str2.Format(_TEXT("len %d data %d: %x %x"), out->d.cfs_ioctl.len,
					out->d.cfs_ioctl.data,
					(DWORD) *(PDWORD) (((PCHAR) out) + (DWORD) out->d.cfs_ioctl.data),
					(DWORD) *(PDWORD) (((PCHAR) out) + (DWORD) out->d.cfs_ioctl.data + sizeof(DWORD)));
				str += str2;
				break;
			}
			SetItemText(m_cMsgs, 2, strvfid);
			SetItemText(m_cMsgs, 3, str);
		}
	}

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

void CCodaMsgList::addOtherMsg(PCHAR p, DWORD cb)
{
	CString str;

	if (!m_bListening)
		return;

	InsertItem(m_cMsgs, _TEXT("Huh?"), 4);

	str.Format (_TEXT("len %d"), cb);
	SetItemText(m_cMsgs, 3, str);

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

#define EDOM		1
#define ERANGE		2
#define E2BIG		3
#define EACCES		4
#define EAGAIN		5
#define EBADF		6
#define EBUSY		7
#define ECHILD		8
#define EDEADLK		9
#define EEXIST		10
#define EFAULT		11
#define EFBIG		12
#define EINTR		13
#define EINVAL		14
#define EIO		15
#define EISDIR		16
#define EMFILE		17
#define EMLINK		18
#define ENAMETOOLONG	19
#define ENFILE		20
#define ENODEV		21
#define ENOENT		22
#define ENOEXEC		23
#define ENOLCK		24
#define ENOMEM		25
#define ENOSPC		26
#define ENOSYS		27
#define ENOTDIR		28
#define ENOTEMPTY	29
#define ENOTTY		30
#define ENXIO		31
#define EPERM		32
#define EPIPE		33
#define EROFS		34
#define ESPIPE		35
#define ESRCH		36
#define EXDEV		37
#define ENMFILE		38
#define EADDRINUSE        1000 /* XXX */
#define EACCESS           1001
#define EPROTONOSUPPORT   1002
#define EWOULDBLOCK       1003
#define ENOTCONN          1004
#define ETIMEDOUT         1005
#define EOPNOTSUPP        1006
#define EDQUOT            1007
#define EALREADY          1008
#define ENOBUFS           1009
#define ETOOMANYREFS      1010
#define ELOOP             1011
#define ESHUTDOWN         1012
#define ETXTBSY           1013

struct CCodaMsgList::stringList CCodaMsgList::m_slOpcode[] = {
  {CFS_ROOT, "CFS_ROOT"},
  {CFS_SYNC, "CFS_SYNC"},
  {CFS_OPEN, "CFS_OPEN"},
  {CFS_CLOSE, "CFS_CLOSE"},
  {CFS_IOCTL, "CFS_IOCTL"},
  {CFS_GETATTR, "CFS_GETATTR"},
  {CFS_SETATTR, "CFS_SETATTR"},
  {CFS_ACCESS, "CFS_ACCESS"},
  {CFS_LOOKUP, "CFS_LOOKUP"},
  {CFS_CREATE, "CFS_CREATE"},
  {CFS_REMOVE, "CFS_REMOVE"},
  {CFS_LINK, "CFS_LINK"},
  {CFS_RENAME, "CFS_RENAME"},
  {CFS_MKDIR, "CFS_MKDIR"},
  {CFS_RMDIR, "CFS_RMDIR"},
  {CFS_READDIR, "CFS_READDIR"},
  {CFS_SYMLINK, "CFS_SYMLINK"},
  {CFS_READLINK, "CFS_READLINK"},
  {CFS_FSYNC, "CFS_FSYNC"},
  {CFS_INACTIVE, "CFS_INACTIVE"},
  {CFS_VGET, "CFS_VGET"},
  {CFS_SIGNAL, "CFS_SIGNAL"},
  {CFS_REPLACE, "CFS_REPLACE"},
  {CFS_FLUSH, "CFS_FLUSH"},
  {CFS_PURGEUSER, "CFS_PURGEUSER"},
  {CFS_ZAPFILE, "CFS_ZAPFILE"},
  {CFS_ZAPDIR, "CFS_ZAPDIR"},
  {CFS_ZAPVNODE, "CFS_ZAPVNODE"},
  {CFS_PURGEFID, "CFS_PURGEFID"},
  {CFS_RDWR, "CFS_RDWR"},
  {ODY_MOUNT, "ODY_MOUNT"},
  {ODY_LOOKUP, "ODY_LOOKUP"},
  {ODY_EXPAND, "ODY_EXPAND"},
  {99, "<<STOP>>"},
  {100, "<<START>>"},
  {0, NULL}
};


struct CCodaMsgList::stringList CCodaMsgList::m_slErrno[] = {
   {EDOM, "EDOM"},
   {ERANGE, "ERANGE"},
   {E2BIG, "E2BIG"},
   {EACCES, "EACCES"},
   {EAGAIN, "EAGAIN"},
   {EBADF, "EBADF"},
   {EBUSY, "EBUSY"},
   {ECHILD, "ECHILD"},
   {EDEADLK, "EDEADLK"},
   {EEXIST, "EEXIST"},
   {EFAULT, "EFAULT"},
   {EFBIG, "EFBIG"},
   {EINTR, "EINTR"},
   {EINVAL, "EINVAL"},
   {EIO, "EIO"},
   {EISDIR, "EISDIR"},
   {EMFILE, "EMFILE"},
   {EMLINK, "EMLINK"},
   {ENAMETOOLONG, "ENAMETOOLONG"},
   {ENFILE, "ENFILE"},
   {ENODEV, "ENODEV"},
   {ENOENT, "ENOENT"},
   {ENOEXEC, "ENOEXEC"},
   {ENOLCK, "ENOLCK"},
   {ENOMEM, "ENOMEM"},
   {ENOSPC, "ENOSPC"},
   {ENOSYS, "ENOSYS"},
   {ENOTDIR, "ENOTDIR"},
   {ENOTEMPTY, "ENOTEMPTY"},
   {ENOTTY, "ENOTTY"},
   {ENXIO, "ENXIO"},
   {EPERM, "EPERM"},
   {EPIPE, "EPIPE"},
   {EROFS, "EROFS"},
   {ESPIPE, "ESPIPE"},
   {ESRCH, "ESRCH"},
   {EXDEV, "EXDEV"},
   {ENMFILE, "ENMFILE"},
   {EADDRINUSE, "EADDRINUSE"},
   {EACCESS, "EACCESS"},
   {EPROTONOSUPPORT, "EPROTONOSUPPORT"},
   {EWOULDBLOCK, "EWOULDBLOCK"},
   {ENOTCONN, "ENOTCONN"},
   {ETIMEDOUT, "ETIMEDOUT"},
   {EOPNOTSUPP, "EOPNOTSUPP"},
   {EDQUOT, "EDQUOT"},
   {EALREADY, "EALREADY"},
   {ENOBUFS, "ENOBUFS"},
   {ETOOMANYREFS, "ETOOMANYREFS"},
   {ELOOP, "ELOOP"},
   {ESHUTDOWN, "ESHUTDOWN"},
   {ETXTBSY, "ETXTBSY"},
   {0, NULL}
};
