// CodaStartDlg.cpp : implementation file
//

#include "stdafx.h"
#include "CodaLSock.h"
#include "CodaMsgList.h"
#include "ProcWatch.h"
#include "CodaStart.h"
#include "CodaStartDlg.h"
 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaStartDlg dialog

CCodaStartDlg::CCodaStartDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCodaStartDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCodaStartDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pCodaMsgList = new CCodaMsgList;
}

void CCodaStartDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCodaStartDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCodaStartDlg, CDialog)
	//{{AFX_MSG_MAP(CCodaStartDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_LISTEN, OnListenBtn)
	ON_BN_CLICKED(IDC_PIPETEST, OnPipetest)
	ON_BN_CLICKED(IDC_STARTVENUS, OnStartVenus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaStartDlg message handlers

BOOL CCodaStartDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	// Listen checkbutton initialization
	m_pListenBtn = (CButton*) GetDlgItem (IDC_LISTEN);
	m_pListenBtn->SetCheck (BST_CHECKED);

	// Listbox initialization
	m_pCodaMsgList->Attach((CListCtrl*) GetDlgItem (IDC_CODAMSG));

	// Status initialization

	m_pProcWatch = new CProcessWatcher(_TEXT("VENUS"), this, IDC_VENUSSTATUS);
	m_pProcWatch2 = new CProcessWatcher(_TEXT("REL"), this, IDC_RELAYSTATUS);
	m_pThread = AfxBeginThread (CCodaStartDlg::Watcher, this);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCodaStartDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCodaStartDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCodaStartDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CCodaStartDlg::OnReset() 
{
	m_pCodaMsgList->Reset();
}

void CCodaStartDlg::OnListenBtn() 
{
	m_pCodaMsgList->SetListen((m_pListenBtn->GetCheck() == BST_CHECKED) ? TRUE : FALSE);
}

UINT CCodaStartDlg::Watcher(LPVOID pParam)
{
	CCodaStartDlg* p = (CCodaStartDlg*) pParam;

	while (1) {
		p->m_pProcWatch->Update();
		p->m_pProcWatch2->Update();
		::Sleep(2000);
	}
	return 0;
}

void CCodaStartDlg::OnPipetest() 
{
	HANDLE hdl;
	struct deviopacket {
		DWORD	cmd;
		struct ViceIoctl {
		    PCHAR in, out;        /* Data to be transferred in, or out */
			short in_size;          /* Size of input buffer <= 2K */
			short out_size;         /* Maximum size of output buffer, <= 2K */
		} VIo; 
		char    filename[100];
	} dp;
	CHAR buf[200];
	DWORD dwNumout;
	struct VolumeStatus {
		DWORD Vid;
		DWORD ParentId;
		UCHAR Online;
		UCHAR InService;
		UCHAR Blessed;
		UCHAR NeedsSalvage;
		DWORD Type;
		DWORD MinQuota;
		DWORD MaxQuota;
		DWORD BlocksInUse;
		DWORD PartBlocksAvail;
		DWORD PartMaxBlocks;
	} *vstat;                       

	hdl = CreateFile("\\\\.\\MC", 0, 0, NULL, 0, 0, NULL);
	if (hdl == INVALID_HANDLE_VALUE) {
		AfxMessageBox(IDP_CREATEFILEFAILED);
		return;
	}

	strcpy(dp.filename, "dir");
	dp.cmd = 4;
	dp.VIo.in = &buf[0];
	dp.VIo.in_size = 10;
	dp.VIo.out = &buf[0];
	dp.VIo.out_size = 200;
	memset(buf, 0, sizeof(buf));
	if (!DeviceIoControl (hdl, 11, &dp, sizeof(dp), NULL, 0, &dwNumout, NULL))
		AfxMessageBox(IDP_TRANSACTFAILED);

	vstat = (struct VolumeStatus *) buf;

	CString str;
	str.Format(_TEXT("%x %d %d %d %d  %d %d %d %d %s"),
				vstat->Vid,
				vstat->Online,
				vstat->InService,
				vstat->Blessed,
				vstat->NeedsSalvage,
				vstat->Type,
				vstat->MinQuota,
				vstat->MaxQuota,
				vstat->BlocksInUse,
				(PCHAR) (vstat + 1)); 

	PCHAR pp = (PCHAR) (vstat + 1);
	pp += strlen(pp) + 1;
	str += pp;
	pp += strlen(pp) + 1;
	str += pp;

/*	CString str2;
	for (int j = 0; j < 10; j++) {
		str2.Format ("%02x", buf[j]);
		str += str2;
	} */
	SetDlgItemText (IDC_PIPERES, str);

	CloseHandle(hdl);
}

void CCodaStartDlg::OnStartVenus() 
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;

	memset (&si, 0, sizeof(si));
	si.cb = sizeof(si);
	si.dwFlags = STARTF_USESHOWWINDOW;
	// si.wShowWindow = SW_HIDE;
	si.wShowWindow = SW_SHOWMINNOACTIVE;

	if (CreateProcess (NULL, "d:\\usr\\coda\\venus.cache\\venus2 -init -d 10 -cf 300",
			NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
		CloseHandle (pi.hProcess);
		CloseHandle (pi.hThread);
	}
}
